/*                                                            -*- C -*-
 * Copyright (c) 2003-2004 Teranishi & Nemoto 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#include <eb/eb.h>
#include <qtranslator.h>
#include <qmainwindow.h>
#include "ztenwindow.h"
#include "zten.h"
#include "diskstat.h"
#include <signal.h>

ZtenWindow *g_w=NULL;

#ifdef QTOPIA
#else
#endif

void sigcont_handler (int)
{
  g_w->resume ();
}


#ifdef QTOPIA

#include <qpe/qpeapplication.h>
QPEApplication *app;

int
main (int argc, char *argv[])
{
  QPEApplication ap(argc, argv);
  app=&ap;
  //  app = new QPEApplication(argc, argv);
  signal (SIGCONT, sigcont_handler);
  QTranslator trans (0);
  trans.load ("ztenv.qm");
  app ->installTranslator (&trans);
  g_w=new ZtenWindow();
  app->showMainWidget(g_w);
  int rv=app->exec();
  delete g_w;
  return rv;
  //  app->processEvents();
  //  return app->exec ();
}

#else

#include <qapplication.h>
#include <qwindowsstyle.h> 
QApplication *app;

int
main (int argc, char *argv[])
{

  app = new QApplication(argc, argv);
  QApplication::setStyle( new QWindowsStyle );

  signal (SIGCONT, sigcont_handler);
  QTranslator trans (0);
  trans.load ("ztenv.qm");
  app ->installTranslator (&trans);

  if (g_book_path[0].path==NULL) {
    g_book_path[0].path=(char *)malloc(EB_MAX_PATH_LENGTH+2);
    strcpy(g_book_path[0].path, getenv("HOME"));
    int len=strlen(g_book_path[0].path);
    if (g_book_path[0].path[len-1]!='/') {
      g_book_path[0].path[len]='/';
      g_book_path[0].path[len+1]='\0';
    }
    strncat(g_book_path[0].path,"dict/",EB_MAX_PATH_LENGTH);
    fprintf(stderr, "HOME=%s\n",g_book_path[0].path);
  }

  ZtenWindow w;

  g_w = &w;
 
  app->setMainWidget(&w);
  w.showMaximized();

  app->processEvents();
  return app->exec ();
}
#endif
