#include <qwidget.h>
#include "qhistorylineedit.h"

QHistoryLineEdit::QHistoryLineEdit (QWidget *parent, const char *name)
  : QComboBox (true, parent, name)
{
  setDuplicatesEnabled (false);
  setInsertionPolicy (QComboBox::AtBottom);
  setAutoCompletion (true);
  insertItem ("", 0);
}

void
QHistoryLineEdit::activate()
{
  int c = count ();
  insertItem (currentText (), c);
  setCurrentItem(c);  
}

void
QHistoryLineEdit::keyPressEvent(QKeyEvent* e)
{
  switch(e->key()) {
  case Qt::Key_Return:
    emit returnPressed ();
    break;
  }
  QComboBox::keyPressEvent(e);
}
