/*                                                            -*- C -*-
 * Copyright (c) 2003-2004 Takashi Nemoto 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#include "utils.h"

const char *
Utils::z2h(char *eucString) {
  // eucString : not const
  //  return eucString;

  static const char table21[]=
    " @@,.@:;?!@@@@@^~_@@@@@@@@@@--/\\~@|@@`'\"\"()"
    "[][]{}<>@@@@@@@@+-@@@=@<>@@@@@@@'\"@\\$@@%#&*@@@@@@@";
  char* base=eucString;
  while (*base != 0) {
    char ch=*(base++), ch2, ch22;
    if ((ch & 0x80) ==0) {
      *(eucString++) = ch;
    } else {
      ch2 = *base;
      ch22 = (ch2 & 0x7f)-0x21;
      switch(ch & 0x7f){
      case 0x23:
	*(eucString++) = 0x7f & *(base++);
	break;
      case 0x21:
	if (/* ch22>=0 && */ ch22<sizeof(table21) && table21[ch22]!='@') {
	  *(eucString++) = table21[ch22];
	  base++;
	  break;
	}
      default:
	*(eucString++)=ch;
	*(eucString++)=ch2;
	base++;
      }
    }
  }
  *eucString = 0;
  return eucString;
};

