/*                                                            -*- C -*-
 * Copyright (c) 2004 Takashi Nemoto 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef ZTENDUMP_H
#define ZTENDUMP_H
#include <qtextcodec.h>
#include <qdialog.h>
#include "qbookentry.h"

class QTextCocec;
class QLineEdit;
class QAction;
class QHBox;
class MyPushButton;
class QTextView;

class ZtenDump : public QDialog
{
  Q_OBJECT
public:
  ZtenDump (QWidget* parent = 0, const char *name = 0, bool modal = FALSE, WFlags fl = 0);
  ~ZtenDump ();

  void setAddress(QBookEntry *be, int page, int offset);
  void setText(const QString &text);

    QLineEdit* DumpPageEntry;
    QLineEdit* DumpOffsetEntry;
    MyPushButton* DumpExecButton;
    QHBox *AddressBar;
    QTextView* TextView;

 private:
  QTextCodec *codec;
  QBookEntry *cbe;

protected slots:
  void go ();
};

#endif // ZTENBOOK_H
