#include "ztenmultisearch.h"
#include "ztencandidate.h"
#include <qlineedit.h>
#include <qlabel.h>
#include <qlistbox.h>
#include "qbookentry.h"
#include "zten.h"
#include "ztenconf.h"
#include "mypushbutton.h"

ZtenMultiSearch::~ZtenMultiSearch() {};

ZtenMultiSearch::ZtenMultiSearch(Zten *zt, QBookMultiSearch *qms, QWidget* parent, const char* name, bool modal, WFlags fl) : MultiSearchBase (parent, name, modal, fl) {
  //  connect (MultiSearch, SIGNAL (activated (int)),
  //	   this, SLOT (multiSelected (int)));
  multi_number = 0;
  ms=qms;
  zten = zt;
  connect (MultiLookup, SIGNAL (clicked ()),
	   this, SLOT (multiSearch ()));
  connect (LineEdit1, SIGNAL (returnPressed ()), this, SLOT (multiSearch()));  
  connect (LineEdit2, SIGNAL (returnPressed ()), this, SLOT (multiSearch()));  
  connect (LineEdit3, SIGNAL (returnPressed ()), this, SLOT (multiSearch()));  
  connect (LineEdit4, SIGNAL (returnPressed ()), this, SLOT (multiSearch()));  
  connect (LineEdit5, SIGNAL (returnPressed ()), this, SLOT (multiSearch()));  

  connect (MultiCandidate1, SIGNAL (clicked ()),
	   this, SLOT (multiCandidate1 ()));
  connect (MultiCandidate2, SIGNAL (clicked ()),
	   this, SLOT (multiCandidate2 ()));
  connect (MultiCandidate3, SIGNAL (clicked ()),
	   this, SLOT (multiCandidate3 ()));
  connect (MultiCandidate4, SIGNAL (clicked ()),
	   this, SLOT (multiCandidate4 ()));
  connect (MultiCandidate5, SIGNAL (clicked ()),
	   this, SLOT (multiCandidate5 ()));

  candidate1 = QString ();
  candidate2 = QString ();
  candidate3 = QString ();
  candidate4 = QString ();
  candidate5 = QString ();

  // FIXME: Hard coding.
  MultiLabel1->setText ("");
  LineEdit1->setEnabled (FALSE);
  LineEdit1->setText ("");
  MultiCandidate1->setEnabled (FALSE);
  if (!candidate1.isNull ())
    candidate1 = QString ();

  MultiLabel2->setText ("");
  LineEdit2->setEnabled (FALSE);
  LineEdit2->setText ("");
  MultiCandidate2->setEnabled (FALSE);
  if (!candidate2.isNull ())
    candidate2 = QString ();
  
  MultiLabel3->setText ("");
  LineEdit3->setEnabled (FALSE);
  LineEdit3->setText ("");
  MultiCandidate3->setEnabled (FALSE);
  if (!candidate3.isNull ())
    candidate3 = QString ();
  
  MultiLabel4->setText ("");
  LineEdit4->setEnabled (FALSE);
  LineEdit4->setText ("");
  MultiCandidate4->setEnabled (FALSE);
  if (!candidate4.isNull ())
    candidate4 = QString ();
  
  MultiLabel5->setText ("");
  LineEdit5->setEnabled (FALSE);
  LineEdit5->setText ("");
  MultiCandidate5->setEnabled (FALSE);
  if (!candidate5.isNull ())
    candidate5 = QString ();

}

void
ZtenMultiSearch::addMultiSearchEntry (QBookEntry *be, int index, QString label,
			   bool have_candidate)
{
  current_book = be;
  multi_number++;
  // qDebug ("%d:%d", index, have_candidate);
  switch (index)
    {
    case 0:
      MultiLabel1->setText (label);
      LineEdit1->setEnabled (TRUE);
      if (have_candidate)
	MultiCandidate1->setEnabled (TRUE);
      break;
    case 1:
      MultiLabel2->setText (label);
      LineEdit2->setEnabled (TRUE);
      if (have_candidate)
	MultiCandidate2->setEnabled (TRUE);
      break;
    case 2:
      MultiLabel3->setText (label);
      LineEdit3->setEnabled (TRUE);
      if (have_candidate)
	MultiCandidate3->setEnabled (TRUE);
      break;
    case 3:
      MultiLabel4->setText (label);
      LineEdit4->setEnabled (TRUE);
      if (have_candidate)
	MultiCandidate4->setEnabled (TRUE);
      break;
    case 4:
      MultiLabel5->setText (label);
      LineEdit5->setEnabled (TRUE);
      if (have_candidate)
	MultiCandidate5->setEnabled (TRUE);
      break;
    default:
      break;
    }
}

void
ZtenMultiSearch::setCandidateLabel (int index, QString text, QString label)
{
  switch (index)
    {
    case 1:
      candidate1 = QString (text);
      LineEdit1->setText (label);
      break;
    case 2:
      candidate2 = QString (text);
      LineEdit2->setText (label);
      break;
    case 3:
      candidate3 = QString (text);
      LineEdit3->setText (label);
      break;
    case 4:
      candidate4 = QString (text);
      LineEdit4->setText (label);
      break;
    case 5:
      candidate5 = QString (text);
      LineEdit5->setText (label);
      break;
    }
}

void
ZtenMultiSearch::multiCandidate1 ()
{
  //  QBookMultiSearch *ms = ms_list.at (MultiSearch->currentItem ());
  fprintf(stderr,"Main Call!\n");
  EB_Position pos;
  EB_Book *book = ms->getBookEntry ()->getBook ();

  if (eb_multi_entry_candidates (book,
				 ms->getMultiId (),
				 0,
				 &pos) == EB_SUCCESS)
    {
      ZtenCandidate c (book, pos, 1, this, 0, true);
      connect (&c, SIGNAL (candidateDecided (int, QString, QString)),
	       this, SLOT (setCandidateLabel (int, QString, QString)));
      c.showMaximized ();
      c.exec ();  
    }
}

void
ZtenMultiSearch::multiCandidate2 ()
{
  //  QBookMultiSearch *ms = ms_list.at (MultiSearch->currentItem ());
  EB_Position pos;
  EB_Book *book = ms->getBookEntry ()->getBook ();
  if (eb_multi_entry_candidates (book,
				 ms->getMultiId (),
				 1,
				 &pos) == EB_SUCCESS)
    {
      ZtenCandidate c (book, pos, 2, this, 0, true);
      connect (&c, SIGNAL (candidateDecided (int, QString, QString)),
	       this, SLOT (setCandidateLabel (int, QString, QString)));
      c.showMaximized ();
      c.exec ();  
    }
}

void
ZtenMultiSearch::multiCandidate3 ()
{
  //  QBookMultiSearch *ms = ms_list.at (MultiSearch->currentItem ());
  EB_Position pos;
  EB_Book *book = ms->getBookEntry ()->getBook ();
  if (eb_multi_entry_candidates (book,
				 ms->getMultiId (),
				 2,
				 &pos) == EB_SUCCESS)
    {
      ZtenCandidate c (book, pos, 3, this, 0, true);
      connect (&c, SIGNAL (candidateDecided (int, QString, QString)),
	       this, SLOT (setCandidateLabel (int, QString, QString)));
      c.showMaximized ();
      c.exec ();  
    }
}

void
ZtenMultiSearch::multiCandidate4 ()
{
  //  QBookMultiSearch *ms = ms_list.at (MultiSearch->currentItem ());
  EB_Position pos;
  EB_Book *book = ms->getBookEntry ()->getBook ();
  if (eb_multi_entry_candidates (book,
				 ms->getMultiId (),
				 3,
				 &pos) == EB_SUCCESS)
    {
      ZtenCandidate c (book, pos, 4, this, 0, true);
      connect (&c, SIGNAL (candidateDecided (int, QString, QString)),
	       this, SLOT (setCandidateLabel (int, QString, QString)));
      c.showMaximized ();
      c.exec ();  
    }
}

void
ZtenMultiSearch::multiCandidate5 ()
{
  //  QBookMultiSearch *ms = ms_list.at (MultiSearch->currentItem ());
  EB_Position pos;
  EB_Book *book = ms->getBookEntry ()->getBook ();
  if (eb_multi_entry_candidates (book,
				 ms->getMultiId (),
				 4,
				 &pos) == EB_SUCCESS)
    {
      ZtenCandidate c (book, pos, 5, this, 0, true);
      connect (&c, SIGNAL (candidateDecided (int, QString, QString)),
	       this, SLOT (setCandidateLabel (int, QString, QString)));      
      c.showMaximized ();
      c.exec ();  
    }
}

void
ZtenMultiSearch::multiSearch ()
{
  // FIXME: qbookentry interface should have EUC API.
  QTextCodec *codec = QTextCodec::codecForName("eucJP");
  if (current_book)
    {
      //      QBookMultiSearch *ms = ms_list.at (MultiSearch->currentItem ());
      QList<QString> multi_words;
      multi_words.setAutoDelete (TRUE);
      if (multi_number >= 1)
	multi_words.append(new QString (candidate1.isNull ()?
					codec->fromUnicode (LineEdit1->text ()) :
					candidate1));
      if (multi_number >= 2)
	multi_words.append(new QString (candidate2.isNull ()?
					codec->fromUnicode (LineEdit2->text ()) :
					candidate2));
      if (multi_number >= 3)
	multi_words.append(new QString (candidate3.isNull ()?
					codec->fromUnicode (LineEdit3->text ()) :
					candidate3));
      if (multi_number >= 4)
	multi_words.append(new QString (candidate4.isNull ()?
					codec->fromUnicode (LineEdit4->text ()) :
					candidate4));	
      if (multi_number == 5)
	multi_words.append(new QString (candidate5.isNull ()?
					codec->fromUnicode (LineEdit5->text ()) :
					candidate5));		
      int matches = current_book->multiSearch (ms->getMultiId (), multi_words);
      zten->EntryList->clear ();
      for (int i = 0; i < matches; i ++)
	{
	  QString heading = current_book->getHeading (i);
	  if (!heading.isNull())
	    {
	      if (config->BookNameBeforeEntry) {
		zten->EntryList->insertItem (new QBookHitItem
					("<font color=\"" +
					 current_book->getAltTitleColor () +
					 "\">" +
					 current_book->getAltTitle () + 
					 "</font> " +
					 heading, 
					 current_book, i), -1);
	      } else {
		zten->EntryList->insertItem (new QBookHitItem
					(heading + " [" +
					 current_book->getTitle () + "]",
					 current_book, i), -1);	  
	      }
	    }
	}
      
      //      MultiTab->setCurrentPage (1);
      //      toggleContentForce2 (FALSE);

      if (matches == 0)
	{
	  zten->EntryList->insertItem (new QBookHitItem ("No matches", NULL, -1));
	  zten->EntryList->setSelectionMode (QListBox::NoSelection);
	}
      else
	{
	  zten->EntryList->setSelectionMode(QListBox::Single);
	  zten->EntryList->setSelected(0, true);
	  zten->EntryList->setFocus();
	  // zten->toggleContentForce (TRUE);
	}
    }
  done(0);
}

/*
void
ZtenMultiSearch::multiResume ()
{
  if (multi_last_book_ident.isNull ())
    {
      MultiSearch->setCurrentItem (0);
      multiSelected (0);
    }
  else
    {
      QBookMultiSearch *ms;
      int count = 0;
      for (ms = ms_list.first (); ms != NULL; ms = ms_list.next ())
	{
	  if (ms->getBookEntry ()->equals (multi_last_book_ident) &&
	      ms->getMultiId () == multi_last_id)
	    {
	      MultiSearch->setCurrentItem (count);
	      multiSelected (count);
	      return;
	    }
	  count++;
	}
      multiSelected (0);
    }
}

bool
ZtenMultiSearch::setupDict(QBookEntry *be) {
  be->findMultiSearchEntry (ms->getMultiId ());
}
*/

  
void 
ZtenMultiSearch::accept() {
  multiSearch();
}
